#include "ops_la.h"
#include "matrix_csr.h"

#include <stdio.h>

int32 main( int32 argc, char **argv )
{
  int32 i, j, col, size, n, nd = 5;
  FILE *file;
  Matrix *a;
  Vector *b;
  Vector *x;
  int32 diag[5] = {-5, -3, 0, 3, 5};
  int32 dval[5] = {1, 2, -8, 2, 1};

  n = 1000000;

  size = nd * n;
  for (i = 0; i < nd; i++) {
    size -= abs( diag[i] );
  }

  file = fopen( "A.big", "w" );
  fprintf( file, "%d %d\n", n, n );
  fprintf( file, "%d\n", size );
  for (i = 0; i < n; i++) {
    for (j = 0; j < nd; j++) {
      col = i + diag[j];
      if ((col < 0) || (col >= n)) continue;
      fprintf( file, "%d %d %d\n", i, col, dval[j] );
    }
  }
  fclose( file );

  mCSR_load( &a, "A.big" );
  v_createAlloc( &x, n );
  v_createAlloc( &b, n );
  la_fill_v( x, 1.0 );

  la_mul_m_v( b, a, x );
  v_save( b, "B.big" );

  v_freeDestroy( &b );
  v_freeDestroy( &x );
  mCSR_freeDestroy( &a );

  return( 0 );
}
