#ifndef _DISTDATA_H_
#define _DISTDATA_H_

#include "types.h"
#include "matrix_csr.h"
#include "vector.h"
#include "itc.h"

int32 dd_placeList2Set( int32 *set, int32 lset, int32 *pl, int32 lpl );

int32 dd_set2PlaceList( int32 *pl, int32 lpl, int32 *set, int32 lset );

int32 dd_localSize( int32 *size, int32 sizeGlobal, int32 nThread );

int32 dd_localIndexSet( int32 **set, int32 *size, int32 nThread );

int32 dd_mCSR_localCommLRIndexSet( int32 *setLR, int32 *nnz,
				   Matrix *m, int32 *set,
				   int32 size );

int32 dd_createCommList( CommList **pcl, int32 rank, int32 nThread,
			 int32 sizePL,
			 int32 sizeI, int32 *setI,
			 int32 *sizeO, int32 **setO );

int32 dd_distribMatrix( Matrix **pmLocal, Matrix **pmLR,
			CommList **pclI, CommList **pclO,
			int32 *psizeLocal, int32 **psetLocal,
			int32 *psizeLR, int32 **psetLR,
			int32 *sizeGlobal, Matrix *m, int32 nThread );

int32 dd_translateGlobal2Local( CommList *clL, CommList *clG,
				int32 size, int32 *set, int32 sizeGlobal );

int32 dd_distribVector( Vector **pv, Vector *vG,
			int32 sizeLocal, int32 *setLocal, int32 nThread );

int32 dd_collectVector( Vector **pvG, Vector *v,
			int32 sizeGlobal, int32 *setLocal, int32 nThread );

#endif
