#ifndef _ITC_H_
#define _ITC_H_

#include "types.h"
#include "matrix.h"

#include <mpi.h>

#define ITC_TagMatrix 100
#define ITC_TagArray 1000
#define ITC_TagValue 10000

#define ITC_TypeInt32 0
#define ITC_TypeFloat64 1

#define ITC_RankAny -1

#define ITC_ReduceRootAll -1
#define ITC_ReduceSum 0

typedef struct {
  int32 rank;
  int32 size;
  int32 *set;
} CommSet;

typedef struct {
  int32 nList;
  CommSet *cs;
} CommList;

int32 itc_init( int32 *pargc, char ***pargv );

int32 itc_finish();

int32 itc_abort( int32 r );

int32 itc_numberOfThreads( int32 *n );

int32 itc_threadRank( int32 *rank );

int32 itc_barrier();

int32 itc_sizeOfITCtype( int32 *size, int32 itct );

int32 itc_ITCtype2MPItype( MPI_Datatype *mpit, int32 itct );

int32 itc_ITCop2MPIop( MPI_Op *mpio, int32 itco );

int32 itc_reduce( void *operand, void *result, int32 count, int32 type,
		  int32 op, int32 root );

int32 itc_mCSR_sendMatrix( Matrix *m, int32 rank, int32 tag );

int32 itc_mCSR_recvMatrix( Matrix **pm, int32 rank, int32 tag );

int32 itc_sendValue( void *a, int32 type, int32 rank, int32 tag );

int32 itc_recvValue( void *a, int32 type,  int32 rank, int32 tag );

int32 itc_sendArray( void *a, int32 length, int32 type,
		     int32 rank, int32 tag );

int32 itc_recvArray( void **pa, int32 *length, int32 type,
		     int32 rank, int32 tag );

int32 itc_recvArrayNA( void *a, int32 *length, int32 supposedLength,
		       int32 type, int32 rank, int32 tag );

int32 itc_recvArrayALNA( void *a, int32 *length, int32 type,
			 int32 rank, int32 tag );

#endif
