#include "memutils.h"
#include "errutils.h"
#include "matrix.h"

/*
 * Allocate matrix structure.
 */
Matrix *allocMatrix()
{
  Matrix *m;
  
  m = (Matrix *) allocMem( sizeof( Matrix ) );
  m->data = 0;

  return( m );
}

/*
 * Free matrix structure.
 */
void freeMatrix( Matrix *m )
{
  freeMem( m );
}

/*
 * Compare matrix items. Used for sorting.
 */
int compareMItem( const void *item1, const void *item2 ) {
  MItem *i1, *i2;
  int ret;
  
  i1 = (MItem *) item1;
  i2 = (MItem *) item2;
  
  ret = i1->row - i2->row;
  if (!ret) ret = i1->col - i2->col;
  if (!ret) g_error = ErrorCompare;
  
  return( ret );
}
