clear;
format long
format compact

ncpu = 1:6;
phaseName = ['    Load          '
             '   Setup          '
	     'Solution of Ax = b'
	     ' Collect          '];
nphase = size( phaseName, 1 );

% Total times.
% Rows correspond to thread numbers, columns to phases.
allt(:,:,1) = [7.93 0    3.56 0;
               7.98 0.34 2.09 0.01;
	       7.95 0.40 1.37 0.02;
	       7.94 0.41 1.10 0.02;
	       7.92 0.42 0.86 0.02;
	       7.94 0.41 0.74 0.02];
% User times.
allt(:,:,2) = [7.14 0    3.21 0;
               7.17 0.32 1.91 0.01;
	       7.05 0.37 1.25 0.02;
	       7.14 0.36 1.01 0.02;
	       7.10 0.38 0.80 0.02;
	       7.10 0.39 0.70 0.02];
% System times.
allt(:,:,3) = [0.11 0 0.03 0;
               0.11 0 0.02 0;
	       0.21 0 0.01 0;
	       0.12 0 0    0;
	       0.15 0 0    0;
	       0.15 0 0    0];

j = 1;
for i = 3
  figure;
  h = plot( ncpu, allt(:,i,j), 'b-' );
  set( h, 'LineWidth', 2, 'Marker', '^', 'MarkerSize', 8 );
  title( phaseName(i,:), 'FontSize', 14 );
  xlabel( 'Number of processors', 'FontSize', 14 );
  ylabel( 'Time [s]', 'FontSize', 14 );
end

for i = ncpu
  speedup(i,:,:) = allt(1,:,:) ./ allt(i,:,:);
end

for i = 3
  figure;
  h = plot( ncpu, speedup(:,i,j), 'b-' );
  set( h, 'LineWidth', 2, 'Marker', '^', 'MarkerSize', 8 );
  title( phaseName(i,:), 'FontSize', 14 );
  xlabel( 'Number of processors', 'FontSize', 14 );
  ylabel( 'Speed-up', 'FontSize', 14 );
end

for i = ncpu
  eff(i,:,:) = speedup(i,:,:) / ncpu(i) * 100;
end

for i = 3
  figure;
  h = plot( ncpu, eff(:,i,j), 'b-' );
  set( h, 'LineWidth', 2, 'Marker', '^', 'MarkerSize', 8 );
  title( phaseName(i,:), 'FontSize', 14 );
  xlabel( 'Number of processors', 'FontSize', 14 );
  ylabel( 'Efficiency [%]', 'FontSize', 14 );
end
