#ifndef _SOLVER_H_
#define _SOLVER_H_

#include "types.h"
#include "vector.h"
#include "matrix.h"
#include "itc.h"

/*
 * Solve A x = b by preconditioned CG. No checks.
 */
int32 sol_PCG( Vector *x, Matrix *a, Vector *b, void *precond,
	       float64 eps, uchar check );

/*
 * Solve A x = b by preconditioned CG in parallel. No checks.
 */
int32 sol_d_PCG( Vector *x, Matrix *a, Matrix *aLR, Vector *b, void *precond,
		 float64 eps, uchar check, CommList *clI, CommList *clO );

#endif
