#ifndef _TIMER_H_
#define _TIMER_H_

#include <sys/times.h>
#include <time.h>     

#ifndef CLK_TCK
#define CLK_TCK CLOCKS_PER_SEC
#endif

typedef struct {
  clock_t ticksStart;
  clock_t ticksEnd;

  time_t userStart;
  time_t userEnd;

  time_t systemStart;
  time_t systemEnd;
} Timer;

void timerReset( Timer *t );
void timerActivate( Timer *t );
void timerStart( Timer *t );
void timerPause( Timer *t );
void timerCurrentStatus( Timer *t, clock_t *ticks,
			 time_t *user, time_t *system );

#endif
